import sys
sys.path.append('../')
from Utility import My_simplified_optics
import inspect


"""
def Wforecast(weather):
    # 実引数の変数名を返す
    #print(Wforecast(t)) #この方法ではつかえない
    frame = inspect.currentframe()
    stack = inspect.getouterframes(frame)
    val_name = stack[1].code_context[0].split('(')[1].split(')')[0]
    return val_name

def fetch_val_name(str_var):
    t = Wforecast(str_var)
    print(t)
    return t

"""

def Swap_dictionary_key_value(dict):
    """
    parameter   : dict{key:value}
    return      : dict{value:key}
    """
    d_swap = {v: k for k, v in dict.items()}
    return d_swap

def Get_model_from_out(out,empty_kat_model):
    """
    out = model.run()
    outを引数でもらって使ったモデルをreturnで返す
    finesseの元の機能になかったので作った
    parameter
    ---------
    empty_kat_model : kat
        Get_model_from_out(out,finesse.kat())
    """
    text = out.katScript
    empty_kat_model.parse(text)
    return empty_kat_model

def remove_header(kat_script):
    """
    description
    空白の行と% Generated by PyKat...の行を消去する

    parameter
        kat_script : string
    return
        kat_script : string
    """
    lines = kat_script.splitlines()  #=> ['AAA', 'BBB', 'CCC']
    for line in lines:
        if '%' in line:
            #print(line)
            lines.remove(line)
    #print(a)
    kat_script = [s for s in lines if s != '']
    kat_script = '\n'.join(kat_script)
    return kat_script

def remainings(model):
    """
    modelを渡すとコンポーネントとコマンドを消去したモデルのstrを返してくれる
    parameters
    ----------
    model   : Kat
    
    return
    ----------
    string_kat
    """
    temp = model#.deepcopy()#deepcopyするとコマンドの名称が勝手に変更されるので使わない方が良い？ ひとまずそのまま使うことにする。

    component_names = temp.components.keys()
    string_kat = str(temp)
    for component_name in component_names:
        this_text_list = temp.components[component_name].getFinesseText()
        for test in this_text_list:
            string_kat = string_kat.replace(test+"\n","")

    command_names = temp.commands.keys()
    string_kat2 = str(temp)
    for command_name in command_names:
        this_text_list2 = temp.commands[command_name].getFinesseText()
        string_kat = string_kat.replace(this_text_list2+"\n","")

    return string_kat

def Get_selected_class_components_list(selected_name,model):

    comonents_dict = Get_component_class_dict(model)
    Mirror_list         = [k for k, v in comonents_dict.items() if v == 'mirror']
    Beam_splitter_list  = [k for k, v in comonents_dict.items() if v == 'beamSplitter']
    Space_list          = [k for k, v in comonents_dict.items() if v == 'space']
    Laser_list          = [k for k, v in comonents_dict.items() if v == 'laser']
    Modulator_list      = [k for k, v in comonents_dict.items() if v == 'modulator']
    Category_dict = {
        "Mirror"        :Mirror_list,
        "Beam splitter" :Beam_splitter_list,
        "space"         :Space_list,
        "laser"         :Laser_list,
        "modulator"     :Modulator_list,
        "commands"      :list(model.commands.keys())
    }

    return Category_dict[selected_name]

def Get_component_class_dict(model):
    """
    modelから辞書を作成する

    return : dict{コンポーネント名 str:クラス名 str}
    """
    #print("Get_component_class_dict")
    #modelに含まれる{コンポーネント名:クラス名}の辞書を作成する
    temp_dict = {}
    for component_name in model.components.keys():
        class_name = model.components.get(component_name).__class__.__name__
        class_name = str(class_name).split('.')[-1]
        class_name = str(class_name).split('_')[0]
        #print(f"Get_component_class_dict     {class_name}")
        temp_dict[component_name] = class_name
    return temp_dict

def classify_model_components(model):
    """
    return : dict{classname str:component_name list[str]}
    """
    temp_dict = Get_component_class_dict(model)
    #print("classify_model_components")
    #コンポーネントクラスの数を調べる
    all_class = []
    for component_name in temp_dict.keys():
        class_name = temp_dict[component_name]
        #print(all_class)
        if not class_name in all_class:
            #print(f"classify_model_components     {class_name}")
            all_class.append(class_name)
        else:
            pass
            #print("aru")

    #コンポーネントクラスの数だけ[初期化したlist]をdictionaryのvalueとして作成 {コンポーネントクラス:初期化したlist}
    classified_dict = {}
    for class_name in all_class:
        classified_dict[class_name]=[]

    #コンポーネントをクラスで分類したdictionaryを作成
    for component_name in temp_dict.keys():
        class_name = temp_dict[component_name]
        classified_dict[class_name].append(component_name)
    
    return classified_dict


def Get_component_attributes(model,component):
    component_name = str(component)
    class_name = Get_component_class_dict(model)[component_name]
    if class_name=="laser":
        parameter_dict = My_simplified_optics.My_simplified_laser(component).simplified_params
    elif class_name=="mirror":
        parameter_dict = My_simplified_optics.My_simplified_mirror(component).simplified_params
    elif class_name=="beamSplitter":
        parameter_dict = My_simplified_optics.My_simplified_beamSplitter(component).simplified_params
    elif class_name=="space":
        parameter_dict = My_simplified_optics.My_simplified_space(component).simplified_params
    elif class_name=="modulator":
        parameter_dict = My_simplified_optics.My_simplified_modulator(component).simplified_params
    return parameter_dict

def add_detector(model,detector_info):
    """
    bp name x/y parameter node

    detector_info = {
    "detector_name" :"aaaaaa",
    "pdtype"        :"x-split"
    "parameter"     :2,
    "port"          :"REFL",
    }

    w : beam radius in metres 
    w0: waist radius in metres 
    z : distance to waist in metres 
    zr: Rayleigh range in metres 
    g : Gouy phase in radians 
    r : Radius of curvature (of phase front) in meters 
    q : Gaussian beam parameter
    
    """
    # detector_info通りのpdを追加する
    model.parse(f"pd {detector_info['detector_name']} {detector_info['port']}")
    model.detectors[detector_info['detector_name']].num_demods = detector_info["num_demods"]
    for i in range(detector_info["num_demods"]):
        num = i+1
        model.detectors[detector_info['detector_name']]._pd__set_f(str(num), detector_info["f"+str(num)])
        model.detectors[detector_info['detector_name']]._pd__set_phi(str(num), detector_info["phi"+str(num)])
    if "pdtype" in detector_info:
        model.detectors[detector_info['detector_name']].pdtype = "x-split"
    # 確認
    #model.detectors[detector_info['detector_name']].getFinesseText()
    return model

def add_bp_detector(model,detector_info):
    
    pass
def isfloat(s):  # 浮動小数点数値かどうかを判定
    try:
        float(s)  # 試しにfloat関数で文字列を変換
    except ValueError:
        return False  # 失敗すれば False
    else:
        return True  # 上手くいけば True

def unit_convert(word):
    """
    単位として書かれた"M"や"μ"や"n"などをfloatに変換して、headとtailに分けて返す
    return
    -------------
    converted_head  : str
    converted_tail  : float
    """
    unit_dictionary = {
        "T":1e12,
        "G":1e9,
        "M":1e6,
        "k":1e3,
        "m":1e-3,
        "μ":1e-6,
        "n":1e-9,
        "p":1e-12,

    }
    converted_tail = 1
    for unit in list(unit_dictionary.keys()):
        if unit in word:
            num = word.count(unit)# 出現回数
            converted_tail = converted_tail * (unit_dictionary[unit]**num)
            word = word.replace(unit,"")
    converted_head = word
    #print(type(converted_head),type(converted_tail))
    return converted_head,converted_tail